Player = {}

  
function getPlayer(x, y)
  -- Asthetics
  Player.scale = 0.5
  Player.image = love.graphics.newImage('images/player/down.png')
  Player.x = x
  Player.y = y
  
  -- Physics
  Player.body = love.physics.newBody(world, Player.x/2+16, Player.y/2+16, "dynamic")
  Player.shape = love.physics.newRectangleShape(15, 15)
  Player.fixture = love.physics.newFixture(Player.body, Player.shape)
  Player.body:setLinearDamping(25)
  Player.fx = 0
  Player.fy = 0
end

function Player.update(dt)
  local down = love.keyboard.isDown
  local force = 1500
  
  -- Add ability to 'sprint'
  if down('lshift') then
    force = 2500
  end
  
  Player.fx = 0
  Player.fy = 0
  
  if down('w') then
    Player.fy = Player.fy - love.physics.getMeter()*dt*force
  end
  if down('s') then
    Player.fy = Player.fy + love.physics.getMeter()*dt*force
  end
  if down('a') then
    Player.fx = Player.fx - love.physics.getMeter()*dt*force
  end
  if down('d') then
    Player.fx = Player.fx + love.physics.getMeter()*dt*force
  end
  
  Player.body:applyForce(Player.fx, Player.fy)
  
  Player.x, Player.y = Player.body:getWorldCenter()
end

function Player.draw()
  local x = Player.x-16
  local y = Player.y-24
  
  love.graphics.draw(Player.image, x, y, 0, Player.scale, Player.scale)
  -- Draw collision box
  if debug then
    love.graphics.polygon('line', Player.body:getWorldPoints(Player.shape:getPoints()))
  end
end